
public class Tablero4 {
	int[][] casillas;
	int[] ultimasCoordenadas;
	public Tablero4() {
		this.casillas = new int[7][6];
		this.ultimasCoordenadas = new int[2];
	}
	
	public boolean colocarFicha(int x, int jugador) {
		if(this.casillas[x][5] == 0) {
			for(int i = 0;i < this.casillas[x].length; i++) {
				if(this.casillas[x][i] == 0) {
					this.casillas[x][i] = jugador;
					this.ultimasCoordenadas[0]=x;
					this.ultimasCoordenadas[1]=i;
					break;
				}
			}
			return true;
		}
		return false;	
		
	}
	
	public int getLastX() {
		return this.ultimasCoordenadas[0];
	}
	
	public int getLastY() {
		return this.ultimasCoordenadas[1];
	}
	
	public String getTablero() {
		String ret = "";
		for(int i = this.casillas[0].length-1; i >= 0; i--) {
			for(int j = 0; j < this.casillas.length; j++) {
				ret += this.casillas[j][i] + " ";
			}
			if(i != this.casillas.length-1) {
				ret += "\n";
			}
			
		}
		return ret;
	}
	
	public int finalJuego() {
        int ret=0;
        for(int i = 0;i < this.casillas.length; i++) {
			for(int j = 0;j < this.casillas[i].length; j++) {
				if(this.casillas[i][j] != 0) {
					if(comprobarHorizontal(i, j, this.casillas[i][j]) >= 3) {
						return this.casillas[i][j];
					}
					if(comprobarVertical(i, j, this.casillas[i][j]) >= 3) {
						return this.casillas[i][j];
					}
					if(comprobarDiagonalArriba(i, j, this.casillas[i][j]) >= 3) {
						return this.casillas[i][j];
					}
					if(comprobarDiagonalAbajo(i, j, this.casillas[i][j]) >= 3) {
						return this.casillas[i][j];
					}
				}
			}
		}
        return ret;
	}
	
	private int comprobarHorizontal(int x, int y, int jugador) {
		if(x == this.casillas.length-1) {
			return 0;
		}
		if(this.casillas[x+1][y] == jugador) {
			return comprobarHorizontal(x+1, y, jugador)+1;
		}else {
			return 0;
		}
	}
	
	private int comprobarVertical(int x, int y, int jugador) {
		if(y == this.casillas[x].length-1) {
			return 0;
		}
		if(this.casillas[x][y+1] == jugador) {
			return comprobarVertical(x, y+1, jugador)+1;
		}else {
			return 0;
		}
	}
	
	private int comprobarDiagonalArriba(int x, int y, int jugador) {
		if(y == this.casillas[x].length-1) {
			return 0;
		}
		if(x == this.casillas.length-1) {
			return 0;
		}
		if(this.casillas[x+1][y+1] == jugador) {
			return comprobarDiagonalArriba(x+1, y+1, jugador)+1;
		}else {
			return 0;
		}
	}
	
	private int comprobarDiagonalAbajo(int x, int y, int jugador) {
		if(y == 0) {
			return 0;
		}
		if(x == this.casillas.length-1) {
			return 0;
		}
		if(this.casillas[x+1][y-1] == jugador) {
			return comprobarDiagonalAbajo(x+1, y-1, jugador)+1;
		}else {
			return 0;
		}
	}
}
